#include <windows.h>
#include <stdio.h>
#include <assert.h>

static WNDPROC old_combobox_proc;

static LRESULT WINAPI combobox_hook_proc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    printf("combo: %p, %04x, %08x, %08lx\n", hwnd, message, wParam, lParam);
    return CallWindowProcA(old_combobox_proc, hwnd, message, wParam, lParam);
}

int main(void)
{
    HWND combo;
    WNDCLASSA cls;
    COMBOBOXINFO cbi;
    BOOL ret;

    cbi.cbSize = sizeof(cbi);
    SetLastError(0xdeadbeef);
    ret = GetComboBoxInfo((HWND)0xdeadbeef, &cbi);
    if (ret)
        printf("GetComboBoxInfo succeeded\n");
    else
        printf("GetComboBoxInfo error %ld\n", GetLastError());

    cbi.cbSize = sizeof(cbi);
    SetLastError(0xdeadbeef);
    ret = GetComboBoxInfo(GetDesktopWindow(), &cbi);
    if (ret)
        printf("GetComboBoxInfo succeeded\n");
    else
        printf("GetComboBoxInfo error %ld\n", GetLastError());

    combo = CreateWindowExA(0, "ComboBox", NULL, WS_POPUP,
                            0,0,0,0, 0, 0, GetModuleHandleA(0), NULL);
    assert(combo);

    cbi.cbSize = sizeof(cbi);
    SetLastError(0xdeadbeef);
    ret = GetComboBoxInfo(combo, &cbi);
    if (ret)
        printf("GetComboBoxInfo succeeded\n");
    else
        printf("GetComboBoxInfo error %ld\n", GetLastError());

    cbi.cbSize = sizeof(cbi) + 1;
    SetLastError(0xdeadbeef);
    ret = GetComboBoxInfo(combo, &cbi);
    if (ret)
        printf("GetComboBoxInfo succeeded\n");
    else
        printf("GetComboBoxInfo error %ld\n", GetLastError());

    DestroyWindow(combo);

    if (!GetClassInfoA(0, "ComboBox", &cls)) assert(0);
    old_combobox_proc = cls.lpfnWndProc;
    cls.hInstance = GetModuleHandleA(0);
    cls.lpfnWndProc = combobox_hook_proc;
    cls.lpszClassName = "myComboBox";
    if (!RegisterClassA(&cls)) assert(0);

    combo = CreateWindowExA(0, "myComboBox", NULL, WS_POPUP,
                            0,0,0,0, 0, 0, GetModuleHandleA(0), NULL);
    assert(combo);

    cbi.cbSize = sizeof(cbi);
    SetLastError(0xdeadbeef);
    ret = GetComboBoxInfo(combo, &cbi);
    if (ret)
        printf("GetComboBoxInfo succeeded\n");
    else
        printf("GetComboBoxInfo error %ld\n", GetLastError());
    DestroyWindow(combo);

    return 0;
}
